#ifndef __MAKET_SERVER_H__
#define __MAKET_SERVER_H__

#include "../util/config.h"
#include "TCP.h"
#include <functional>
class EthernetMaketClient;
class EthernetMaketServer : EthernetServer
{
private:
    EthernetClient available();
    void accept(int sock);
    std::function<void(EthernetMaketClient)> serverHandler = [](EthernetMaketClient sclient) {};
    bool wasConnected[MAX_SOCK_NUM];

public:
    using EthernetServer::EthernetServer;
    EthernetMaketClient available(int sock);

    void setServerHandler(std::function<void(EthernetMaketClient)> handler);
    void resetServerHandler();
    void begin() override;
    void begin(int sock);
    void tick();
};

#endif // __MAKET_SERVER_H__
